//---------------------------------------------------------------------------------
// File Name: RaceTrack.h
// Description:
//
// Copyright (C) 2004 - 2006 True Axis Pty Ltd, Australia. 
// All Rights Reserved.
//
// Use of this code is covered by the "TRUE AXIS PHYSICS SDK DEMOS SOURCE LICENSE AGREEMENT".
// Details of this agreement are found in the file "TrueAxisPhysicsSDKDemosSourceLicence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.
//
// History:
//		Created File.
//---------------------------------------------------------------------------------

#ifndef TA_RACETRACK_H
#define TA_RACETRACK_H

#include "../TA/Common/MFrame.h"

struct IMesh;
struct IApp;
namespace TA { class StaticObject; }

class RaceTrack
{	
public:
	struct Straight
	{
		TA::Vec3 v3Start;
		TA::Vec3 v3End;
	};

	RaceTrack();
	~RaceTrack();

	void Initialise(IApp* pApp, const char* szFileName);
	void Finalise();

	void Render();
	
	const Straight& GetStraight(int nIndex) const { return m_pStraightArray[nIndex]; }
	int GetNumSegments() const { return m_nStraigtArraySize; }
	TA::MFrame GetStartFrame(int nGridIndex);
	
private:
	int m_nStraigtArraySize;
	Straight* m_pStraightArray;
	IMesh* m_pMesh;
	TA::StaticObject* m_pStaticObject;
};

#endif // TA_RACETRACK_H