//---------------------------------------------------------------------------------
// File Name: IApp.h
// Description: 	
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia. 
// All Rights Reserved.
//
// Use of this code is covered by the "TRUE AXIS PHYSICS SDK DEMOS SOURCE LICENSE AGREEMENT".
// Details of this agreement are found in the file "TrueAxisPhysicsSDKDemosSourceLicence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.
//
// History:
//		Created File.
//---------------------------------------------------------------------------------

#ifndef TA_IAPP_H
#define TA_IAPP_H

struct IMouse;
struct ICamera;
struct IMesh;
struct IStaticGeometry;

namespace TA
{
	struct Vec3;
}

struct IApp
{
public:
	virtual IMouse* CreateMouse() = 0;
	virtual ICamera* CreateCamera() = 0;
	virtual IMesh* CreateMesh() = 0;
	virtual IStaticGeometry* CreateStaticGeometry() = 0;

	virtual void RenderLine(const TA::Vec3& v3A, const TA::Vec3& v3B, unsigned int nDiffuse) = 0;
	virtual void RenderPolygon(int nNumVertices, const TA::Vec3* pPositionList, const TA::Vec3* pNormalList) = 0;
	virtual void RenderText(const char* szString, ...) = 0;
};

#endif // TA_IAPP_H
