//---------------------------------------------------------------------------------
// File Name: IDemoPlugin.h
// Description: 	
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia. 
// All Rights Reserved.
//
// Use of this code is covered by the "TRUE AXIS PHYSICS SDK DEMOS SOURCE LICENSE AGREEMENT".
// Details of this agreement are found in the file "TrueAxisPhysicsSDKDemosSourceLicence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.
//
// History:
//		Created File.
//---------------------------------------------------------------------------------

#ifndef TA_IDEMOPLUGIN_H
#define TA_IDEMOPLUGIN_H

struct IApp;

struct IDemoPlugin
{
public:
	virtual void Release() = 0;
	virtual void Update(float fDt) = 0;
	virtual void Render() = 0;
};

typedef IDemoPlugin* (__stdcall *IDemoPlugin_FnCreate)(IApp* pApp);
#ifdef ALL_IN_ONE
#define TA_IMPLEMENT_DEMO_PLUGIN(ClassName)								\
	IDemoPlugin* __stdcall IDemoPlugin_Create_##ClassName(IApp* pApp)	\
{																		\
	ClassName* pDemoPlugin = new ClassName;								\
	pDemoPlugin->Initialise(pApp);										\
	return pDemoPlugin;													\
}
#else
#define TA_IMPLEMENT_DEMO_PLUGIN(ClassName)								\
IDemoPlugin* __stdcall IDemoPlugin_Create(IApp* pApp)					\
{																		\
	ClassName* pDemoPlugin = new ClassName;								\
	pDemoPlugin->Initialise(pApp);										\
	return pDemoPlugin;													\
}
#endif

#endif // TA_IDEMOPLUGIN_H
