//---------------------------------------------------------------------------------
// File Name: IMesh.h
// Description: 	
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia. 
// All Rights Reserved.
//
// Use of this code is covered by the "TRUE AXIS PHYSICS SDK DEMOS SOURCE LICENSE AGREEMENT".
// Details of this agreement are found in the file "TrueAxisPhysicsSDKDemosSourceLicence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.
//
// History:
//		Created File.
//---------------------------------------------------------------------------------


#ifndef TA_IMESH_H
#define TA_IMESH_H

namespace TA
{
	struct Vec3;
	struct Vec2;
};

struct IMesh
{
public:
	virtual void Initialise(int nNumVertices, int nNumIndices, const char* szTextureName) = 0;
	virtual void Release() = 0;

	virtual void Render() = 0;

	virtual void AddVertex(const TA::Vec3& v3Pos, const TA::Vec2& v2T0, unsigned int nDiffuse = 0xFFFFFFFF) = 0;
	virtual void AddTriangle(int nA, int nB, int nC) = 0;

	virtual void FinishedAddingGeometry() = 0;
};

#endif // TA_IMESH_H
