//---------------------------------------------------------------------------------
// File Name: IStaticGeometry.h
// Description: 	
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia. 
// All Rights Reserved.
//
// Use of this code is covered by the "TRUE AXIS PHYSICS SDK DEMOS SOURCE LICENSE AGREEMENT".
// This agreement is describe the file "TrueAxisPhysicsSDKDemosSourceLicence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.
//
// History:
//		Created File.
//---------------------------------------------------------------------------------

#ifndef TA_ISTATICGEOMETRY_H
#define TA_ISTATICGEOMETRY_H

namespace TA
{
	struct Vec3;
};

struct IStaticGeometry
{
public:
	virtual void Initialise(const char* szFileName, float fScale) = 0;
	virtual void Release() = 0;

	virtual void Render() = 0;

	virtual int GetNumVertices() const = 0;
	virtual int GetNumTriangles() const = 0;

	virtual bool Lock() = 0;
	virtual void Unlock() = 0;
	// These functions are only valid between a lock and unlock
	virtual const TA::Vec3& GetVertexPosition(int nIndex) const = 0;
	virtual int GetTriangleVertexIndex(int nTriangle, int nIndex) const = 0;
};

#endif // TA_ISTATICGEOMETRY_H
